#include"service.h"
#include"lcd.h"


void ATF_Main(void);
void ATF_Command(WORD Command, DWORD Param1, DWORD Param2);

void ATF_Init()
{
#ifndef __SIM_DEBUG__
  SRV_STATUS ret;
  
  //I/O|[gȂǃ}CR̓WX^
  SRV_Init();
  
  //LANM3069̏ꍇ̂݃lbg[N
  SRV_LanmInit(0x03);

  //C֐o^
  //SRV_SetMain(ATF_Main);

  //R}hnho^
  SRV_SetCommand(ATF_Command);
#endif
}


#define LCDC_SET_PORT   0x01
#define LCDC_READ_REG   0x02
#define LCDC_READ_DATA  0x03
#define LCDC_WRITE_REG  0x04
#define LCDC_WRITE_DATA 0x05
#define LCDC_INIT       0x06
#define LCDC_PUTS       0x07

void ATF_Main(void)
{
}


void ATF_Command(WORD Command, DWORD Param1, DWORD Param2)
{
  BYTE bBuff[257];
  
  switch(Command){
  //--------------------------------------------------------------------------
  case LCDC_SET_PORT: //|[gw
    LCD_SetPort(Param1);
    break;
  //--------------------------------------------------------------------------
  case LCDC_READ_REG: //䃌WX^̃[h
  	bBuff[0] = LCD_ReadReg();
    SRV_Transmit(bBuff, 1, 1);
    break;
  //--------------------------------------------------------------------------
  case LCDC_READ_DATA: //f[^RAM̃[h
    bBuff[0] = LCD_ReadData();
    SRV_Transmit(bBuff, 1, 1);
    break;
  //--------------------------------------------------------------------------
  case LCDC_WRITE_REG: //䃌WX^̃Cg
    LCD_WriteReg((BYTE)Param1);
    break;
  //--------------------------------------------------------------------------
  case LCDC_WRITE_DATA: //f[^RAM̃Cg
    LCD_WriteData((BYTE)Param1);
    break;
  //--------------------------------------------------------------------------
  case LCDC_INIT: //LCD̏
    LCD_Init();
    break;
  //--------------------------------------------------------------------------
  case LCDC_PUTS: //J[\ʒuɕ\
    if(Param1 > 256) Param1 = 256;
    //݃oCg̃f[^zXgM
    if(SRV_Receive(bBuff, (WORD)Param1, 1)) break; //G[̏ꍇ
    bBuff[Param1] = '\0'; //Ō'\0'ǉ
    LCD_Puts((const char *)bBuff);
    break;
  }
  return;
}
