Attribute VB_Name = "USBM3069"
'******************************************************************************
'   M3069}CR{[hDLL(USBM3069.DLL)p`t@C VBΉ
'
'   2005/11/11 Ver.2.1.0.1 : 2.0t@[EFAΉ
'   2006/8/21  Ver.2.2.0.1 : DLL2.2Ή萔ǉUSBM_GetFTHandle()ǉ
'   2007/1/15  Ver.2.2.0.2 : USBM_TCPYSetPatternCtrl()̈Xg̃oOC
'   2007/2/14  Ver.3.1.0.1 : LANM3069Ή
'   2007/10/18  Ver.3.3.0.1 : [U[t@[ɑΉ
'******************************************************************************

'------------------------------------------------------------------------------
'   FTD2XX.h Ή
'------------------------------------------------------------------------------

'Device status
Public Enum USBM_FTD2XX_STATUS
    FT_OK
    FT_INVALID_HANDLE
    FT_DEVICE_NOT_FOUND
    FT_DEVICE_NOT_OPENED
    FT_IO_ERROR
    FT_INSUFFICIENT_RESOURCES
    FT_INVALID_PARAMETER
    FT_INVALID_BAUD_RATE
    FT_DEVICE_NOT_OPENED_FOR_ERASE
    FT_DEVICE_NOT_OPENED_FOR_WRITE
    FT_FAILED_TO_WRITE_DEVICE
    FT_EEPROM_READ_FAILED
    FT_EEPROM_WRITE_FAILED
    FT_EEPROM_ERASE_FAILED
    FT_EEPROM_NOT_PRESENT
    FT_EEPROM_NOT_PROGRAMMED
    FT_INVALID_ARGS
    FT_NOT_SUPPORTED
    FT_OTHER_ERROR
End Enum

'Device status
Public Enum M3069_STATUS
    TW_OK
    TW_INVALID_HANDLE
    TW_DEVICE_NOT_FOUND
    TW_DEVICE_NOT_OPENED
    TW_IO_ERROR
    TW_INSUFFICIENT_RESOURCES
    TW_INVALID_PARAMETER
    TW_INVALID_BAUD_RATE
    TW_DEVICE_NOT_OPENED_FOR_ERASE
    TW_DEVICE_NOT_OPENED_FOR_WRITE
    TW_FAILED_TO_WRITE_DEVICE
    TW_EEPROM_READ_FAILED
    TW_EEPROM_WRITE_FAILED
    TW_EEPROM_ERASE_FAILED
    TW_EEPROM_NOT_PRESENT
    TW_EEPROM_NOT_PROGRAMMED
    TW_INVALID_ARGS
    TW_NOT_SUPPORTED
    TW_OTHER_ERROR
'>Ver.3.1.0.x
    TW_TIMEOUT = &HFFFF0001 'M܂͎M^CAEg
    TW_FILE_ERROR           't@CɊւG[
    TW_MEMORY_ERROR         '̊mۃG[
    TW_DATA_NOT_FOUND       'Lȃf[^
    TW_SOCKET_ERROR         'Socket API ̃G[
    TW_ACCESS_DENIED        'F؃G[
'<Ver.3.1.0.x
End Enum

'>Ver.3.1.0.x

'ii[p\
Public Type UUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

Public Type USBM_PRODUCT_INFO
    Empty As Integer
    wRsv As Integer
    ID As UUID
    Number As Long
    Description As String * 32
    Manufacture As String * 32
    Reserve(39) As Byte
End Type
'<Ver.3.1.0.x

'>Ver.3.3.0.1

'ATF̏擾邽߂̍\
Public Type USBM_ATF_INFO
  FormatVer As Long          't@CtH[}bg̃o[W
  FirmwareVer As Long        'Kvȃt@[EFÃo[W
  Description As String * 32 'ATF̖́AȂ
  Manufacture As String * 32 '
  ProgramVer As Long         '[߂ĂvÕo[W
  AddressTop As Long         'gpRAM̈̐擪AhX
  AddressBottom As Long      'gpRAM̈̍ŏIAhX+1
  CommandAddress As Long     'R}hnh̃AhX
  EncryptMode As Integer     'Í(0:ȂA1:\A2:[U[pX[hɂÍ)
  wRsv As Integer
  MainAddress As Long        'C֐̃AhX
End Type
'<Ver.3.3.0.1

'------------------------------------------------------------------------------
'   USBM3069.h ΉF萔`
'------------------------------------------------------------------------------
'>Ver.3.1.0.x
Public Const USBM_IF_USB = &H80000000 'USBC^tF[X
Public Const USBM_IF_LAN = &H40000000 'LANC^tF[X
Public Const USBM_IF_ANY = &HFF000000 'SẴC^tF[Xƃ}b`

Public Const USBM_LIST_UPDATE = &H1   'LANfoCX̓e[uXV邩̃tO
'<Ver.3.1.0.x

'>Ver.3.3.0.1
Public Const TW_ATF_STATUS = &HFFFFFE00  'ATFŋʂɎgpXe[^X̐擪ԍ
Public Const TW_USER_STATUS = &HFFFFFF00 '[U[`̃Xe[^X̐擪ԍ
'<Ver.3.3.0.1

'Xe[^X
Public Const USBM_STS_TIMEOUT = &H1
Public Const USBM_STS_ILLEGAL_ACCESS = &H2

'|[gAhX
Public Const USBM_POUT = &HFFFFFFFF  'POUT(o͐p)ʂ̃AhX
Public Const USBM_P1 = &HFFFFD0      'P1(͐p)
Public Const USBM_P2 = &HFFFFD1      'P2(͐p)
Public Const USBM_P4 = &HFFFFD3      'P4(o)
Public Const USBM_P5 = &HFFFFD4      'P5(͐p)
Public Const USBM_PA = &HFFFFD9      'PA(o)

'DARo[^̃AhX
Public Const USBM_DA0 = &HFFFF9C
Public Const USBM_DA1 = &HFFFF9D

'OoX̃AhX
Public Const USBM_AREA0_TOP = &H100000
Public Const USBM_AREA2_TOP = &H400000
Public Const USBM_AREA3_TOP = &H600000
Public Const USBM_AREA5_TOP = &HA00000
Public Const USBM_USER_AREA = &HFFBF20

'PCs(IRQ)ǂނ߂IO|[gAhX
Public Const USBM_PC0_ADDR = &HFFFFD8
Public Const USBM_PC1_ADDR = &HFFFFD8
Public Const USBM_PC2_ADDR = &HFFFFD7
Public Const USBM_PC3_ADDR = &HFFFFD7

'PCs(IRQ)ǂނ߂̃rbg}XN
Public Const USBM_PC0_BIT = &H10
Public Const USBM_PC1_BIT = &H20
Public Const USBM_PC2_BIT = &H2
Public Const USBM_PC3_BIT = &H4

'16rbg^C}NbN
Public Const USBM_TCLK25000 = &H0       '25MHz
Public Const USBM_TCLK12500 = &H1       '12.5MHz
Public Const USBM_TCLK6250 = &H2        '625kHz
Public Const USBM_TCLK3125 = &H3        '3125kHz
Public Const USBM_TCLKA = &H4           'TCLKA
Public Const USBM_TCLKB = &H5           'TCLKB

'TCPY(8rbg^C})p
Public Const USBM_TCLK390 = &H6         '390.625kHz
Public Const USBM_TCLK3 = &H7           '3052Hz
Public Const USBM_TCLKUP = &H8          'ONbNオ
Public Const USBM_TCLKDOWN = &H9        'ONbN
Public Const USBM_TCLKBOTH = &HA        'ONbNGbW

Public Const USBM_SCI_DATA8 = &H0       '8rbgf[^
Public Const USBM_SCI_DATA7 = &H40      '7rbgf[^
Public Const USBM_SCI_NOPARITY = &H0    'peBȂ
Public Const USBM_SCI_EVEN = &H20       'peB
Public Const USBM_SCI_ODD = &H30        'peB
Public Const USBM_SCI_STOP1 = &H0       '1Xgbvrbg
Public Const USBM_SCI_STOP2 = &H8       '2Xgbvrbg
Public Const USBM_SCI_BAUD300 = &H2A2   '9rbg=CKS1,8rbg=CKS0,7-0rbg=BRR,
Public Const USBM_SCI_BAUD600 = &H250
Public Const USBM_SCI_BAUD1200 = &H1A2
Public Const USBM_SCI_BAUD2400 = &H150
Public Const USBM_SCI_BAUD4800 = &HA2
Public Const USBM_SCI_BAUD9600 = &H50
Public Const USBM_SCI_BAUD14400 = &H35
Public Const USBM_SCI_BAUD19200 = &H28
Public Const USBM_SCI_BAUD38400 = &H13

'GA\萔
Public Const USBM_AREA0 = &H1
Public Const USBM_AREA2 = &H4
Public Const USBM_AREA3 = &H8
Public Const USBM_AREA5 = &H10

'pXJE^\萔
Public Const USBM_PC0 = &H10
Public Const USBM_PC1 = &H20
Public Const USBM_PC2 = &H2
Public Const USBM_PC3 = &H4
Public Const USBM_PC_ALL = -1

' Purge rx and tx buffers
Public Const FT_PURGE_RX = 1
Public Const FT_PURGE_TX = 2
Public Const USBM_PURGE_RX = 1
Public Const USBM_PURGE_TX = 2

'16rbg^C}CvbgLv`pGbWݒ
Public Const USBM_CAPT_RISE = &H4
Public Const USBM_CAPT_FALL = &H5
Public Const USBM_CAPT_BOTH = &H7

'------------------------------------------------------------------------------
'   USBM3069.h ΉF֐`
'------------------------------------------------------------------------------

Public Declare Function USBM_ListDevices Lib "USBM3069.dll" Alias "USBM_ListDevices2" (ByRef pSerial() As String) As Long
Public Declare Function USBM_ListDevicesByID Lib "USBM3069.dll" Alias "USBM_ListDevicesByID2" (ByVal VID As Integer, ByVal pID As Integer, ByRef pSerial() As String) As Long
Public Declare Function USBM_OpenByUA Lib "USBM3069.dll" (ByVal pUA As String, ByVal nUA As Long) As Long
Public Declare Function USBM_Open Lib "USBM3069.dll" (Optional ByVal pSerial As String = vbNullString) As Long
Public Declare Function USBM_OpenByID Lib "USBM3069.dll" (ByVal VID As Integer, ByVal pID As Integer, Optional ByVal pSerial As String = vbNullString) As Long
Public Declare Function USBM_Close Lib "USBM3069.dll" (ByVal hDev As Long) As Long

Public Declare Function USBM_Initialize Lib "USBM3069.dll" (ByVal hDev As Long) As Long
Public Declare Function USBM_AddressEnable Lib "USBM3069.dll" (ByVal hDev As Long, ByVal nBits As Long) As Long
Public Declare Function USBM_CSEnable Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Area As Long) As Long
Public Declare Function USBM_BusSetWait Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Area As Long, ByVal Wait As Byte) As Long

Public Declare Function USBM_PortRead8 Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Port As Long, ByRef pData As Byte) As Long
Public Declare Function USBM_PortWrite8 Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Port As Long, ByVal Data As Byte) As Long
Public Declare Function USBM_PortRead16 Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Port As Long, ByRef pData As Integer) As Long
Public Declare Function USBM_PortWrite16 Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Port As Long, ByVal Data As Integer) As Long
Public Declare Function USBM_PortBWrite Lib "USBM3069.dll" Alias "USBM_PortBWrite2" (ByVal hDev As Long, ByVal Port As Long, ByRef pData() As Any, ByVal nData As Long, _
Optional ByVal Inc As Long = 1, Optional ByVal Dma As Byte = 1) As Long
Public Declare Function USBM_PortBRead Lib "USBM3069.dll" Alias "USBM_PortBRead2" (ByVal hDev As Long, ByVal Port As Long, ByRef pData() As Any, ByVal nData As Long, _
Optional ByVal Inc As Long = 1, Optional ByVal Dma As Byte = 1) As Long
Public Declare Function USBM_PortSetDir Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Port As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_PortBCopy Lib "USBM3069.dll" (ByVal hDev As Long, ByVal SrcPort As Long, ByVal DstPort As Long, ByVal nData As Long, ByVal SrcInc As Long, ByVal DstInc As Long) As Long
Public Declare Function USBM_PortCopy8 Lib "USBM3069.dll" (ByVal hDev As Long, ByVal SrcPort As Long, ByVal DstPort As Long) As Long
Public Declare Function USBM_PortCopy16 Lib "USBM3069.dll" (ByVal hDev As Long, ByVal SrcPort As Long, ByVal DstPort As Long) As Long

Public Declare Function USBM_TimerEnable Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte, ByVal MDF As Long) As Long
Public Declare Function USBM_TimerSetLevel Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_TimerSetPulse Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal High As Integer, ByVal Low As Integer) As Long
Public Declare Function USBM_TimerSetClk Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_TimerSetCnt Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Cnt As Integer) As Long
Public Declare Function USBM_TimerStart Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_TimerReadCnt Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByRef pCnt As Integer) As Long
Public Declare Function USBM_TimerSetCmp Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CmpA As Integer, ByVal CmpB As Integer) As Long
Public Declare Function USBM_TimerSetCmpOut Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CmpReg As Long, ByVal Port As Long, ByVal Data As Byte) As Long
Public Declare Function USBM_TimerSetCmpClr Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long

Public Declare Function USBM_ADRead Lib "USBM3069.dll" Alias "USBM_ADRead2" (ByVal hDev As Long, ByRef pData() As Integer, ByVal CH As Long, Optional ByVal Scan As Long = 0) As Long
Public Declare Function USBM_ADSetCycle Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Cmp As Byte, Optional ByVal CLK As Long = USBM_TCLK3125) As Long
Public Declare Function USBM_ADBRead Lib "USBM3069.dll" Alias "USBM_ADBRead2" (ByVal hDev As Long, ByRef pData() As Integer, ByVal nData As Long, ByVal CH As Long, ByRef pnRead As Long) As Long

Public Declare Function USBM_SCISetMode Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, Optional ByVal Mode As Long = &H0, Optional ByVal Baud As Long = &H50) As Long
Public Declare Function USBM_SCIReadStatus Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByRef pStatus As Byte, ByRef pnReceive As Long) As Long
Public Declare Function USBM_SCIRead Lib "USBM3069.dll" Alias "USBM_SCIRead2" (ByVal hDev As Long, ByVal CH As Long, ByRef pData() As Byte, ByVal nData As Long, ByRef pnRead As Long) As Long
Public Declare Function USBM_SCIWrite Lib "USBM3069.dll" Alias "USBM_SCIWrite2" (ByVal hDev As Long, ByVal CH As Long, ByRef pData() As Byte, ByVal nData As Long) As Long
Public Declare Function USBM_SCISetTimeout Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Millisec As Long) As Long

Public Declare Function USBM_PCSetCmp Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Cmp As Long) As Long
Public Declare Function USBM_PCSetCnt Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Cnt As Long) As Long
Public Declare Function USBM_PCReadCnt Lib "USBM3069.dll" Alias "USBM_PCReadCnt2" (ByVal hDev As Long, ByVal CH As Long, ByRef pCnt() As Long) As Long
Public Declare Function USBM_PCSetControl Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_PCSetCondBit Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Port As Long, ByVal Mask As Byte) As Long
Public Declare Function USBM_PCSetCmpOut Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Port As Long, ByVal Data As Byte) As Long
Public Declare Function USBM_PCStart Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long

Public Declare Function USBM_TCPYStart Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_TCPYSetParm Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal SrcPort As Long, ByVal DstPort As Long, ByVal nCopy As Long, ByVal SrcInc As Long, ByVal DstInc As Long, ByVal lLoop As Long) As Long
Public Declare Function USBM_TCPYSetCmp Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Cmp As Byte) As Long
Public Declare Function USBM_TCPYSetClk Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal CLK As Long) As Long
Public Declare Function USBM_TCPYSetCycle Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Cmp As Byte, Optional ByVal CLK As Long = USBM_TCLK3125) As Long

Public Declare Function USBM_Write Lib "USBM3069.dll" Alias "USBM_Write2" (ByVal hDev As Long, ByRef Data() As Any, ByVal nData As Long, ByRef pWritten As Long) As Long
Public Declare Function USBM_Read Lib "USBM3069.dll" Alias "USBM_Read2" (ByVal hDev As Long, ByRef Data() As Any, ByVal nData As Long, ByRef pRead As Long) As Long
Public Declare Function USBM_ReadStatus Lib "USBM3069.dll" (ByVal hDev As Long, ByRef pStat As Long) As Long
Public Declare Function USBM_ReadVersion Lib "USBM3069.dll" (ByVal hDev As Long, ByRef pVer As Long) As Long

Public Declare Function USBM_Abort Lib "USBM3069.dll" (ByVal hDev As Long) As Long

Public Declare Function USBM_TimerStartA Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte, Optional ByVal TrigPC As Long = -1, Optional ByVal Repeat As Long = False, Optional ByVal Cmp As Long = 1) As Long
Public Declare Function USBM_TimerStop Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte, Optional ByVal TrigPC As Long = -1, Optional ByVal Repeat As Long = False, Optional ByVal Cmp As Long = 1) As Long
Public Declare Function USBM_DASetCycle Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Cmp As Long, ByVal CLK As Long) As Long
Public Declare Function USBM_DASetParm Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal SrcPort As Long, ByVal nData As Long, ByVal lLoop As Long) As Long
Public Declare Function USBM_DAReadStatus Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByRef pnData As Long) As Long
Public Declare Function USBM_DAStart Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_DAStop Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_TCPYSetPatternCtrl Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal SrcPort As Long, ByVal DstPort As Long, ByVal nCopy As Long, ByVal nSrc As Long, ByVal SrcInc As Long, Optional ByVal Start As Long = 0, Optional ByVal Mask As Byte = &HFF) As Long
Public Declare Function USBM_TCPYSetTrig Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal StartPC As Long, ByVal StopPC As Long, ByVal flgRepeat As Long) As Long
Public Declare Function USBM_TCPYReadStatus Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByRef pnData As Long, ByRef pnCopy As Long) As Long
Public Declare Function USBM_TimerSetCapture Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, Optional ByVal EdgeA As Byte = USBM_CAPT_RISE, Optional ByVal EdgeB As Byte = USBM_CAPT_RISE) As Long
Public Declare Function USBM_TimerReadCaptureCnt Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByRef pCntA As Long, ByRef pCntB As Long) As Long
Public Declare Function USBM_TimerSetCaptureCnt Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, Optional ByVal CntA As Long = 0, Optional ByVal CntB As Long = 0) As Long

Public Declare Function USBM_ADStart Lib "USBM3069.dll" (ByVal hDev As Long, ByVal nCnv As Long, ByVal CH As Long, ByVal Scan As Long, Optional ByVal lByte As Long = False, Optional ByVal Trig As Long = False) As Long
Public Declare Function USBM_ADCopy Lib "USBM3069.dll" (ByVal hDev As Long, ByVal DstPort As Long, ByVal nCnv As Long, ByVal CH As Long, ByVal CKS As Long, ByVal DMA_CH As Long, ByVal DstInc As Long) As Long
Public Declare Function USBM_ADReadCopyStatus Lib "USBM3069.dll" (ByVal hDev As Long, ByRef pnCnv As Long, ByVal DMA_CH As Long) As Long
Public Declare Function USBM_ADReadCopyBuffer Lib "USBM3069.dll" Alias "USBM_ADReadCopyBuffer2" (ByVal hDev As Long, ByVal Port As Long, ByRef ppData() As Integer, ByVal nData As Long, ByVal Inc As Long, ByVal Dma As Byte) As Long
Public Declare Function USBM_ADStopCopy Lib "USBM3069.dll" (ByVal hDev As Long, ByVal DMA_CH As Long) As Long
Public Declare Function USBM_SCISetDelimiter Lib "USBM3069.dll" Alias "USBM_SCISetDelimiter2" (ByVal hDev As Long, ByVal CH As Long, ByRef ppData() As Byte, ByVal nDelimiter As Long) As Long
Public Declare Function USBM_GetQueueStatus Lib "USBM3069.dll" (ByVal hDev As Long, ByRef pnQueue As Long) As Long
Public Declare Function USBM_Purge Lib "USBM3069.dll" (ByVal hDev As Long, ByVal dwMask As Long) As Long
Public Declare Function USBM_SetTimeouts Lib "USBM3069.dll" (ByVal hDev As Long, ByVal dwReadTimeout As Long, ByVal dwWriteTimeout As Long) As Long
Public Declare Function USBM_PCStartA Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_PCStop Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Bits As Byte) As Long
Public Declare Function USBM_TimerSetSinglePulse Lib "USBM3069.dll" (ByVal hDev As Long, ByVal CH As Long, ByVal Setup As Long, ByVal Width As Long, Optional ByVal Pos As Long = False) As Long

Public Declare Function USBM_GetFTHandle Lib "USBM3069.dll" (ByVal hDev As Long) As Long

Public Declare Function FT_Purge Lib "FTD2XX.dll" (ByVal hDev As Long, ByRef dwMask As Long) As Long
Public Declare Function FT_SetTimeouts Lib "FTD2XX.dll" (ByVal hDev As Long, ByVal dwReadTimeout As Long, ByVal dwWriteTimeout As Long) As Long

'>Ver.3.1.0.x
Public Declare Function USBM_ReadPI Lib "USBM3069.dll" (ByVal hDev As Long, ByRef pInfo As USBM_PRODUCT_INFO) As Long
Public Declare Function USBM_OpenByPI Lib "USBM3069.dll" (ByRef phDev As Long, ByVal pUuid As String, ByVal Number As Long, ByVal Opt As Long) As Long
Public Declare Function USBM_PortWrite8A Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Port As Long, ByVal Data As Byte, Optional ByVal Mask As Byte = &HFF) As Long

Public Declare Function USBM_SetPassword Lib "USBM3069.dll" (Optional ByVal pPass As String = vbNullString) As Long
Public Declare Function USBM_SetNetworkPort Lib "USBM3069.dll" (Optional ByVal PortNumber As Long = 0) As Long
Public Declare Function USBM_GetIFType Lib "USBM3069.dll" (ByVal hDev As Long) As Long
Public Declare Function USBM_OpenA Lib "USBM3069.dll" (ByRef phDev As Long, Optional ByVal pID As String = vbNullString, Optional ByVal Opt As Long = USBM_IF_ANY Or USBM_LIST_UPDATE) As Long
Public Declare Function USBM_ListDevicesA Lib "USBM3069.dll" (ByRef pnDev As Long, ByVal pID As String, ByRef pnID As Long, ByVal Opt As Long) As Long
'<Ver.3.1.0.x

'>Ver.3.3.0.1
Public Declare Function USBM_ReadVersionA Lib "USBM3069.dll" (ByVal hDev As Long, ByRef pVersion As Long) As Long
Public Declare Function USBM_ATFSetCommand Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Address As Long) As Long
Public Declare Function USBM_ATFSetMain Lib "USBM3069.dll" (ByVal hDev As Long, ByVal Address As Long) As Long
Public Declare Function USBM_ATFUserCommand Lib "USBM3069.dll" Alias "USBM_ATFUserCommand2" (ByVal hDev As Long, ByVal Command As Integer, ByVal Param1 As Long, ByVal Param2 As Long, Optional ByRef pData As Variant, Optional ByVal nData As Long = 0) As Long
Public Declare Function USBM_ATFDownload Lib "USBM3069.dll" (ByVal hDev As Long, ByVal FileName As String, Optional ByVal Reserve As String = vbNullString) As Long
Public Declare Function USBM_ATFGetInfo Lib "USBM3069.dll" (ByVal FileName As String, ByRef pInfo As USBM_ATF_INFO) As Long
'<Ver.3.3.0.1


'------------------------------------------------------------------------------
'   l^ϊp֐
'------------------------------------------------------------------------------
Public Function USBM_ToUINT16(ByVal Data As Long) As Integer

    If Data < 0 Then
        USBM_ToUINT16 = 0
    ElseIf Data <= &H7FFF& Then
        USBM_ToUINT16 = Data
    ElseIf Data <= &HFFFF& Then
        USBM_ToUINT16 = (Data - &H10000)
    Else
        USBM_ToUINT16 = &HFFFF
    End If

End Function

Public Function USBM_ToINT32(ByVal Data As Integer) As Long

    USBM_ToINT32 = Data
    USBM_ToINT32 = USBM_ToINT32 And &HFFFF&

End Function



