/*****************************************************************************
  M3069pLCDCu(lcd.c)
  
  M3069pLCDCułBLN^^CvLCD𐧌䂵܂B

  EЂ͖{vOA܂́ẢϕɊ֘AĐQɊւĈ؂̐
    C𕉂܂B
  
  Copyright (C) eNmEF[u 2007
*****************************************************************************/
#include "service.h"
#include "lcd.h"

static BYTE *g_pLcdDDR = 0xfee003; //l=P4DDR
static BYTE *g_pLcdDR = 0xffffd3;  //l=P4DR

#define LCD_DDR (*g_pLcdDDR)
#define LCD_DR  (*g_pLcdDR)


/***************************************************************************
  BOOL LCD_Wait()

  ߂l : ÎƂTRUEA^CAEĝƂFALSE

  LCDfBɂȂ̂҂܂B
****************************************************************************/
static BOOL LCD_Wait()
{
  BYTE Data;
  int i;

  for(i=0;i<10000;i++){  //BF0ɂȂ܂Ń[v
    Data = LCD_ReadReg();
    if((Data & 0x80) == 0) return TRUE;
    SRV_StimeUpdate();   //VXe^C}XV
  }
  return FALSE;
}


/***************************************************************************
  BYTE LCD_ReadReg()
  
  ߂l : ǂݏoWX^l
  
  LCDC^tF[X烌WX^ǂݏo܂B
****************************************************************************/
BYTE LCD_ReadReg()
{
  BYTE bData;

  LCD_DDR = 0x0f;   //DB4-DB7͂ɕύX

  LCD_DR = 0x02;
  LCD_DR = 0x06;
  bData = LCD_DR & 0xf0;
  LCD_DR = 0x02;
    
  LCD_DR = 0x02;
  LCD_DR = 0x06;
  bData = bData | ((LCD_DR & 0xf0) >> 4);
  LCD_DR = 0x02;

  LCD_DR = 0x00;
  LCD_DDR = 0xff;   //So
  
  return bData;
}


/****************************************************************************
  BYTE LCD_ReadData()

  ߂l : ǂݏof[^l
  
  LCDC^tF[Xf[^ǂݏo܂B
****************************************************************************/
BYTE LCD_ReadData()
{
  BYTE bData;

  LCD_DDR = 0x0f;   //DB4-DB7͂ɕύX

  LCD_DR = 0x03;
  LCD_DR = 0x07;
  bData = LCD_DR & 0xf0;
  LCD_DR = 0x03;
    
  LCD_DR = 0x03;
  LCD_DR = 0x07;
  bData = bData | ((LCD_DR & 0xf0) >> 4);
  LCD_DR = 0x03;

  LCD_DR = 0x00;
  LCD_DDR = 0xff;   //So
  
  return bData;
}


/****************************************************************************
  BOOL LCD_WriteReg(BYTE bData)

  bData : WX^ɏރR}hl
          LCD_CLEAR(0x01)       ʂNAăJ[\z[ɖ߂
          LCD_HOME(0x02)        J[\z[ɖ߂
          LCD_ENABLE(0x0c)      \
          LCD_CRSR_ENABLE(0x0a) J[\\
          LCD_CRSR_BLINK(0x09)  J[\ʒu̕uN
          LCD_DISABLE(0x08)     \It
          LCD_CRSR_LEFT(0x10)   J[\Ɉړ
          LCD_CRSR_RIGHT(0x14)  J[\EɈړ
          LCD_SCRL_LEFT(0x18)   ʂɃXN[
          LCD_SCRL_RIGHT(0x1c)  ʂEɃXN[
          LCD_SET_DDRAM(0x80)   DDRAMAhXZbg
          LCD_SET_CGRAM(0x40)   CGRAMAhXZbg

  ߂l : ÎƂTRUEALCDfBɂȂȂꍇFALSE
  
  LCD̃WX^ɃR}h݂܂B
  LCD_ENABLEALCD_CRSR_ENABLEALCD_CRSR_BLINK3ORŌAɎw
  \łB
****************************************************************************/
BOOL LCD_WriteReg(BYTE bData)
{
  LCD_DR = bData & 0xf0;  //4rbg   
  LCD_DR = (bData & 0xf0) | 0x04;
  SRV_StimeSleep(0);
  LCD_DR = bData & 0xf0;
  SRV_StimeSleep(0);

  bData <<= 4;

  LCD_DR = bData & 0xf0;  //4rbg   
  LCD_DR = (bData & 0xf0) | 0x04;
  SRV_StimeSleep(0);
  LCD_DR = bData & 0xf0;
  SRV_StimeSleep(0);

  LCD_Wait();
}


/****************************************************************************
  BOOL LCD_WriteData(BYTE bData)

  ߂l : ÎƂTRUEALCDfBɂȂȂꍇFALSE

  LCDɃf[^݂܂B
****************************************************************************/
BOOL LCD_WriteData(BYTE bData)
{
  LCD_DR = (bData & 0xf0) | 0x01;  //4rbg   
  LCD_DR = (bData & 0xf0) | 0x05;
  SRV_StimeSleep(0);
  LCD_DR = (bData & 0xf0) | 0x01;
  SRV_StimeSleep(0);

  bData <<= 4;

  LCD_DR = (bData & 0xf0) | 0x01;  //4rbg   
  LCD_DR = (bData & 0xf0) | 0x05;
  SRV_StimeSleep(0);
  LCD_DR = (bData & 0xf0) | 0x01;
  SRV_StimeSleep(0);

  return LCD_Wait();
}


/****************************************************************************
  BOOL LCD_Init()

  ߂l : ÎƂTRUEALCDfBɂȂȂꍇFALSE

  LCD܂B
****************************************************************************/
BOOL LCD_Init()
{
  LCD_DR = 0xf0;   //LCD_DȐ
  LCD_DDR = 0xff;  //SẴrbgo
  
  LCD_DR = 0x30;   //
  LCD_DR = 0x34;
  SRV_StimeSleep(0); //220nsȏ҂
  LCD_DR = 0x30;
  SRV_StimeSleep(5); //4.1msȏ҂
  
  LCD_DR = 0x30;
  LCD_DR = 0x34;
  SRV_StimeSleep(0); //220nsȏ҂
  LCD_DR = 0x30;
  SRV_StimeSleep(1); //100usȏ҂
  
  LCD_DR = 0x30;
  LCD_DR = 0x34;
  SRV_StimeSleep(0); //220nsȏ҂
  LCD_DR = 0x30;
  SRV_StimeSleep(0); //220nsȏ҂
  
  LCD_DR = 0x20;     //C^tF[X4rbgɐݒ
  LCD_DR = 0x24;
  SRV_StimeSleep(0); //220nsȏ҂
  LCD_DR = 0x20;
  SRV_StimeSleep(0); //220nsȏ҂

  if(!LCD_Wait()) return FALSE; //BF0ɂȂ̂҂

  LCD_WriteReg(0x28);  //t@NVZbg(4bit,1/16f[eB)
  LCD_WriteReg(0x08);  //\It
  LCD_WriteReg(0x01);  //\NA
  LCD_WriteReg(0x06);  //Gg[[h(AhX+1,Eړ,XN[Ȃ)
  
  return TRUE;
}


/****************************************************************************
  BOOL LCD_Puts(const char *pText)

  ߂l : ÎƂTRUEAG[ꍇFALSE

  ݂̃J[\ʒuɕo͂܂B
****************************************************************************/
BOOL LCD_Puts(const char *pText)
{
  while(*pText){
    if(!LCD_WriteData(*pText++)) return FALSE;
  }
}


/****************************************************************************
  void LCD_SetPort(DWORD Port)

  LCDC^tF[XŎgp|[gw肵܂B
****************************************************************************/
void LCD_SetPort(DWORD Port)
{
  g_pLcdDR = (BYTE*)Port; //gp|[gDRAhXZbg
  g_pLcdDDR = (BYTE*)(Port - 0x11fd0); //gp|[gDDRAhXvZ
}
