/*****************************************************************************
  service.h

  {T[rX֐pwb_t@C

  Copyright (C)eNmEF[u 2007
*****************************************************************************/
#ifndef __SERVICE_H__
#define __SERVICE_H__

#include "types.h"

typedef short SRV_STATUS;

//G[Xe[^X
enum{
  SRVS_OK,             //I
  SRVS_TIMEOUT,        //^CAEg
  SRVS_INVALID_ARGS,   //ȃp[^
  SRVS_NOT_SUPPORTED,  //T|[gȂ@\
  SRVS_NO_CONNECTION,  //Ƃ̐ڑ؂Ă
  SRVS_SOCKET_ERROR,   //̑\Pbg֐̃G[
  SRVS_INVALID_MAC,    //MACAhXs
  SRVS_INVALID_IP,     //IPAhXs
  SRVS_DNS_FAILURE,    //DNS̎s
  SRVS_INVALID_SOCKET, //`ls
  SRVS_NO_CONFIG       //RtBM[V񂪖
};

//lbg[Nݒۑp\
typedef struct {
  BYTE MAC[6];        //MACAhX
  BYTE IP[4];         //IPAhX
  BYTE Gateway[4];    //GatewayIPAhX
  BYTE Subnetmask[4]; //Subnet Mask
  WORD Port;          //Portԍ
  BYTE rsv1[32];      //\
  BYTE DnsServer[4];  //DNST[o[
  BYTE rsv2[70];      //\
} LANM_CONFIG;


//LANMXe[g
#define LANMS_INIT       0x0001 //ԁBlbg[N͎gpł܂
#define LANMS_READY      0x0002 //lbg[N̏IԁB`l͐ڑĂ܂B
#define LANMS_CONNECT    0x0004 //`lzXgƐڑꂽ
#define LANMS_DISCONNECT 0x0008 //`lؒfꂽ
#define LANMS_DHCP_FLAG  0x8000 //DHCPgpĂ邩ǂtO
#define LANMS_ENABLE     0x000e //lbg[Ngp\ȏԂ̂ǂꂩ    

//LANMIvV
#define LANMM_ENABLE_CONTROL 0x0001 //`l(0)gp
#define LANMM_ENABLE_LIST    0x0002 //p\R̃XgAbvvɉ

//T[rX֐}N
#define SRV_GetVersion() (**(DWORD**)0x000200)
#define SRV_Init (*((void (**)())0x000204))
#define SRV_GetStackSize (*((long (**)())0x000208))
#define SRV_SetVect (*( (void(*(**)(short Number, void (*pNewHandler)()))())0x00020c))
#define SRV_SetCommand (*( (void(*(**)(void (*pCommand)(WORD, DWORD, DWORD)))(WORD, DWORD, DWORD))0x000210))
#define SRV_SetMain (*( (void(*(**)(void (*pMain)(void)))(void))0x000214))
#define SRV_DmaCopy (*((void (**)(void *, void *, WORD, int, int))0x000218))
#define SRV_StimeUpdate (*((DWORD (**)())0x00021c))
#define SRV_StimeGetTime (*((DWORD (**)(DWORD *))0x000220))
#define SRV_StimeSleep (*((void (**)(DWORD))0x000224))
#define SRV_StimeSetAutoUpdate (*((void (**)(BOOL))0x000228))
#define SRV_IsTXE (*((short (**)())0x00022c))
#define SRV_IsRXF (*((short (**)())0x000230))
#define SRV_Transmit (*((SRV_STATUS (**)(void *, WORD, short))0x000234))
#define SRV_Receive (*((SRV_STATUS (**)(void *, WORD, short))0x000238))
#define SRV_DmaTransmit (*((SRV_STATUS (**)(void *, WORD, short))0x00023c))
#define SRV_DmaReceive (*((SRV_STATUS (**)(void *, WORD, short))0x000240))
#define SRV_SetTimeouts (*((void (**)(WORD, WORD))0x000244))
#define SRV_LanmReadConfig (*((SRV_STATUS (**)(LANM_CONFIG *pConfig))0x000248))
#define SRV_LanmInit (*((SRV_STATUS (**)(DWORD Option))0x00024c))
#define SRV_LanmCheckState (*((SRV_STATUS (**)(WORD *pLanmState))0x000250))
#define SRV_SetNetConfig (*((SRV_STATUS (**)(BYTE *pMac, BYTE *pIP, BYTE *pGateway, BYTE *pSubnetmask))0x000254))
#define SRV_GetNetConfig (*((SRV_STATUS (**)(BYTE *pMac, BYTE *pIP, BYTE *pGateway, BYTE *pSubnetmask))0x000258))
#define SRV_SetDnsServer (*((SRV_STATUS (**)(BYTE *pIP))0x00025c))
#define SRV_GetDnsServer (*((SRV_STATUS (**)(BYTE *pIP))0x000260))
#define SRV_DebugInit 0x000264
#define SRV_GetTime (*((long (**)(long *timeptr))0x000268))
#define SRV_SetTime (*((SRV_STATUS (**)(long Time))0x00026c))
#define SRV_SyncTime (*((SRV_STATUS (**)(int ch, BYTE *pServerAddr, DWORD Timeout))0x000270))

#endif __SERVICE_H__


/*----------------------------------------------------------------------------
  ėp֐
-----------------------------------------------------------------------------/
/*****************************************************************************
  DWORD SRV_GetVersion()
  
  ߂l : t@[EFÃo[Wԍ

  t@[EFÃo[WԍԂ܂B
*****************************************************************************/

/*****************************************************************************
  long SRV_GetStackSize()
  
  ߂l : X^bÑTCY
  
  X^bN̎ceʂvZ܂B
*****************************************************************************/

/*****************************************************************************
  void (*SRV_SetVect(short Number, void (*pNewHandler)()))()
  
  Number      : 荞ݔԍ
  pNewHandler : nhւ̃|C^
  
  ߂l      : Ânhւ̃|C^
  
  ẘ荞ݔԍɃnho^AÂnhւ̃|C^Ԃ܂B
*****************************************************************************/

/*****************************************************************************
  void (*SRV_SetEntry(void (*pEntry)(WORD, DWORD, DWORD)))(WORD, DWORD, DWORD)
  
  pEntry : o^R}hnhւ̃|C^
      
  ߂l : ÂR}hnh̃AhX
  
  R}hnh̃AhXo^܂BUSBMCu烆[U[`̃R}
  hMƂɂт֐o^܂BR}hnh̃vg^
  Cv͈ȉłB

  void FunctionName(WORD Command, DWORD Param1, DWORD Param2);

  Command : [U[`̃R}hԍ
  Param1  : [U[`̃p[^1
  Param2  : [U[`̃p[^2
*****************************************************************************/

/*****************************************************************************
  void (*SRV_SetMain(int (*pMain)(void)))(void)
  
  pMain : o^main()ւ̃|C^
      
  ߂l : Âmain()֐ւ̃|C^
  
  main()̃AhXo^܂Bmain()֐̓ftHg̃t@[EFÃR}
  h[v̒IɌĂяo֐łBzXgp\R̃R}h
  ֌WɎIȏsꍇɎgp܂Bmain()֐烊^[Ȃ
  R}h[vsȂ߁AUSBMCũR}h͎󂯕t܂
  Bmain()֐̃vg^Cv͈ȉłB

  void main(void);
*****************************************************************************/

/*****************************************************************************
  void SRV_DmaCopy(void *pSrc, void *pDst, WORD n, int SrcInc, int DstInc)

  pSrc   : [in]]AhX
  pDst   : [in]]AhX
  n      : f[^̃oCg(0̂Ƃ65536oCg])
  SrcInc : ]AhX̃CNg(l̈ӖDstIncƓ)
  DstInc : ]AhX̃CNg
           1 ]pbCNg
           0 pSrc͌Œ
          -1 ]pbfNg

  DMAgpăԂ̃f[^]s܂Bo[Xg[hœ]邽߁A
  荞݂󂯕t܂B
*****************************************************************************/


/*----------------------------------------------------------------------------
  VXe^C}֐

  VXe^C}֘Å֐BVXe^C}8rbg^C}2`lgp
  ŇoߎԂL^܂BLANM3069ł̓VXe^C}K{ł̂ŊY^
  C}`l͎gpł܂B
  ftHgł͎Ԃ̍XV͎ł͂܂̂ŒӂĂBōXV
  邽߂ɂSRV_StimeSetAutoUpdate()֐Ăяo܂BXVɂƃ^C
  }I[o[t[閈Ɋ荞݃[`Ăяo܂̂ŁAptH[}
  Xɑ̉e^܂B
-----------------------------------------------------------------------------/
/*****************************************************************************
  DWORD SRV_StimeUpdate(void)

  ߂l : 83.9msecɃCNg32rbg̃JEgl

  VXe^C}̃JEgXV܂BVXe^C}8rbg^C}2g
  ŇoߎԂL^܂B^C}̃I[o[t[ĎA8192~256
  TCN32rbg̃JE^l1CNg܂AftHg
  Ԃł̓I[ot[̃`FbN͎ł͂܂̂ŁA83.9msecɂ̊֐
  ĂяoăJE^̍XVsĂB
*****************************************************************************/

/*****************************************************************************
  void SRV_StimeSetAutoUpdate(BOOL flgAutoUpdate)

  flgAutoUpdate : XV̋/֎~
                  TRUE  
                  FALSE ֎~

  VXe^C}̎XVݒ肵܂BXVɂƒIɊ荞ݏ
  s܂B
*****************************************************************************/

/*****************************************************************************
  DWORD SRV_StimeGetTime(DWORD *pHigh)
  
  pHigh : 32rbgȏ̌̊i[

  VXeŇoߎԂmsecPʂŕԂ܂BpHighNULLȊOw肷
  32rbgŕ\łȏ̎Ԃ擾ł܂B߂l"Low"Ƃƌoߎ
  ͈ȉ̎ŌvZł܂B

  *pHigh * (2 ^ 32) + Low [msec]

  oߎԂ͖41690ɖ߂܂B
*****************************************************************************/

/*****************************************************************************
  void SRV_StimeSleep(DWORD Millisec)
  
  Millisec : X[vԂmsecPʂŎw肵܂

  w莞ԃX[v܂B
*****************************************************************************/

/*****************************************************************************
  long SRV_GetTime(long *timeptr)

  timeptr : ̊i[

  ߂l  : timeptrɕԂlƓ

  VXẽJ_[v̎擾܂B1970/1/1NZb
  UTCŕԂ܂BANSItime()֐Ɠl̋@\łB
*****************************************************************************/

/*****************************************************************************
  SRV_STATUS SRV_SetTime(long Time)

  Time : ݒ肷鎞(̒l̂)

  VXẽJ_[v̎ݒ肵܂B1970/1/1NZb
  UTCœn܂(ANSItime_tϐƓľ`)B
  VXe̎NTPvgR̃^CX^vƓlA1900NNZ
  bŊǗ邽߁A2036N2762815b̎͐ݒł܂B
*****************************************************************************/


/*----------------------------------------------------------------------------
  C^tF[X֐

  zXgp\RUSBMCuƒʐM邽߂̊֐
-----------------------------------------------------------------------------/
/*****************************************************************************
  short SRV_IsTXE()

  USBM3069ł͑M\łTRUEAȊOFALSEԂ܂B
  LANM3069ł͑Mobt@̋󂫂oCgPʂŕԂ܂B
*****************************************************************************/

/*****************************************************************************
  short SRV_IsRXF()

  USBM3069ł͎M\ȃf[^TRUEAȊOFALSEԂ܂B
  LANM3069ł͎Mobt@̃f[^oCgPʂŕԂ܂B
*****************************************************************************/

/*****************************************************************************
  SRV_STATUS SRV_Transmit(void *pSrc, WORD n, short Inc)

  pSrc : [in]Mf[^
  n    : f[^̃oCg(0̂Ƃ65536oCgM)
  inc  : CNg
          1 ]pbCNg
          0 pSrc͌Œ
         -1 ]pbfNg

  w̃f[^zXgɑM܂BzXgp\Rł͑Mf[^USBMC
  uUSBM_Read()֐ŎoƂł܂B
*****************************************************************************/

/*****************************************************************************
  SRV_STATUS SRV_Receive(void *pDst, WORD n, short Inc)

  pDst : [out]f[^̊i[
  n    : f[^̃oCg(0̂Ƃ65536oCgM)
  Inc  : CNg
          1 ]pDstCNg
          0 pDst͌Œ
         -1 ]pDstfNg

  woCg̃f[^zXgM܂BzXgp\Rf[^𑗐M
  ꍇUSBMCuUSBM_Write()֐gp܂B
*****************************************************************************/

/*****************************************************************************
  SRV_STATUS SRV_DmaTransmit(void *pSrc, WORD n, int Inc)

  pSrc : [in]Mf[^
  n    : f[^̃oCg(0̂Ƃ65536oCgM)
  inc  : CNg
          1 ]pbCNg
          0 pSrc͌Œ
         -1 ]pbfNg

  woCg̃f[^𑗐M܂BDMA]gp܂B
  USBM3069̏ꍇ]IPA1TEND#Mo͂̂łӂB
*****************************************************************************/

/*****************************************************************************
  SRV_STATUS SRV_DmaReceive(void *pDst, WORD n, short Inc)

  pDst : [out]f[^̊i[
  n    : f[^̃oCg(0̂Ƃ65536oCgM)
  Inc  : CNg
          1 ]pDstCNg
          0 pDst͌Œ
         -1 ]pDstfNg

  wԒnɎwoCg̃f[^M܂BDMA]gp܂B
  USBM3069̏ꍇ]IPA0TEND#Mo͂̂łӂB
*****************************************************************************/

/*****************************************************************************
  void SRV_SetTimeouts(WORD TxTimeout, WORD RxTimeout)

  TxTimeout : M^CAEg(msecP)
  RxTimeout : M^CAEg(msecP)

  /M^CAEgԂ̐ݒ
*****************************************************************************/


/*----------------------------------------------------------------------------
  LANM֐

  LANM3069p̐֐
-----------------------------------------------------------------------------/
/*****************************************************************************
  [LANp]
  SRV_STATUS SRV_LanmReadConfig(LANM_CONFIG *pConfig)

  pConfig : [out]LANM_CONFIG\̂ւ̃|C^
  
  tbVɃlbg[ÑRtBM[V񂪂Γǂݏo
  B̃RtBM[VLanmToolsŐݒł܂B񂪖ꍇA
  SRVS_NO_CONFIGԂ܂B
  ɕKvĂяoKv͂܂B
*****************************************************************************/

/*****************************************************************************
  [LANp]
  SRV_STATUS SRV_LanmInit(DWORD Option)

  Option : LANM3069̓ݒBȉ̒lORőgݍ킹Ďw
           LANMM_ENABLE_CONTROL `l(0)gp
           LANMM_ENABLE_LIST    p\R̃XgAbvvɉ
           
  LANM3069ɕKvȏƑSʁBtbV̕ۑ̈悩lbg[N
  ݒǂݎAW3150A+`bv܂B
  
  lbg[NݒEێIɍsꍇAŏɂ̊֐Ăяo܂B
  ̌AISRV_LanmCheckState()ĂяoĂB

  VXełW3150A+̃`lő3`lgp܂B1̓zXgp\
  RUSBMCuƒʐM邽߂̐`lB2߂̓zXgp\R
  lbg[ÑfoCXT߂Ɏgp郊XgAbvp̃`lB3
  ߂DHCP𗘗p邽߂DHCPp`lłB

  `l0`lgp܂BLANMM_ENABLE_CONTROLw肵Ȃ
  ꍇA[U[gpł܂ASRV_Transmit()ASRV_Receive()Ȃǂ̊֐
  gpł܂B܂AUSBMCuɂ鐧łȂȂ܂B

  XgAbvp`ĺADHCPgpȂꍇ1ADHCPgpꍇ2`
  lgp܂BLANMM_ENABLE_LISTw肵ȂꍇAY`lR
  gpł܂AUSBMCuUSBM_ListDevicesA()ɉȂȂ܂B
  ̏ꍇAfoCXւ̐ڑɂIPAhX̎w肪K{ɂȂ܂B
  ܂AzXgp\RڑAXe[gLANMS_CONNECTƂȂĂԂ͂
  ̃`l͎gp܂̂ŁAꎞIɑ̗prŎgp邱Ƃł܂B

  DHCPp`l1`lgp܂BLȌŒIPݒ肳Ăꍇ
  ̃`l͎gp܂B

  USBMCuƂ̒ʐMKvȂꍇOption0ƂĂB̏ꍇA
  0,2,3`lRɎgpł܂B1`lgpł邩DHCP̗v
  ɂ܂B
*****************************************************************************/

/*****************************************************************************
  [LANp]
  SRV_STATUS SRV_LanmCheckState(WORD *pLanmState)

  pLanmState : [out]LANM3069̏Ԃi[܂B

  LANM3069̏Ԃ`FbN܂B`lDHCP̊Ǘ̂߂ɒI
  ĂяoKv܂B֐ňȉ̍Ƃs܂B
  EKeepAliveɂ鐧p`l̏Ԃ̃`FbN
  EDHCP̍XV̊ĎƍXV
  EVXe^C}̍XV

  pLanmStateɂ͈ȉ̊eXe[ĝꂩi[܂B

  LANMS_INIT(0x0001)       ԁBlbg[N͎gpł܂
  LANMS_READY(0x0002)      lbg[N͎gp\B`l͎gps
  LANMS_CONNECT(0x0004)    `lzXgp\RƐڑꂽ
  LANMS_DISCONNECT(0x0008) zXgp\RƂ̐ڑؒfꂽ

  ܂ADHCPgpĂꍇ͏L̒lɈȉ̃tOrbgORŌĊi
  [܂B

  LANMS_DHCP_FLAG(0x8000)  DHCPgprbg

  LANMS_INITԂł̓\Pbg֐Ȃǂgpălbg[NɃANZX
  Ƃł܂B

  LANMS_CONNECT̏ԂłSRV_Transmit()ASRV_Receive()gpUSBMCu
  Ƃ̒ʐM\łB
  
  LANMS_DISCONNECT͈ꎞIȏԂłBzXgp\Rڑ؂ꂽƂ
  ܂BXgAbvp`l𗘗pĂꍇɂ́AĐڑɔă`l
  N[YĉKv܂B
*****************************************************************************/

/*****************************************************************************
  [LANp]
  SRV_STATUS SRV_SyncTime(int ch, BYTE *pServerAddr, DWORD Timeout);

  ch          : gp`l
  pServerAddr : NTPT[o[IPAhX
  Timeout     : ^CAEg(msecP)

  SNTPvgRgpĎwNTPT[o[ƁAVXẽJ_[v𓯊
  ܂BpServerAddr  NULL ƂƗ\ߓo^ꂽT[o[Ɠ܂A
  ̃T[o[ɑ΂镉ׂ邽߁A\ł΃[JT[o[Ȃǂ
  p悤ɂĂB
*****************************************************************************/


/*----------------------------------------------------------------------------
  lbg[Nݒ֐

  LANM3069p̃lbg[Nݒp֐
-----------------------------------------------------------------------------/
/*****************************************************************************
  [LANp]
  SRV_STATUS SRV_SetNetConfig(BYTE *pMAC, BYTE *pIP, 
                              BYTE *pGateway, BYTE *pSubnetmask)

  pMAC        : [in]MACAhX(6oCg)
  pIP         : [in]IPAhX(4oCg)
  pGateway    : [in]ftHgQ[gEFC(4oCg)
  pSubnetmask : [in]Tulbg}XN(4oCg)

  lbg[NݒsAW3150A+܂B
*****************************************************************************/

/*****************************************************************************
  [LANp]
  SRV_STATUS SRV_GetNetConfig(BYTE *pMAC, BYTE *pIP, 
                              BYTE *pGateway, BYTE *pSubnetmask)

  pMAC        : [out]MACAhX(6oCg)
  pIP         : [out]IPAhX(4oCg)
  pGateway    : [out]ftHgQ[gEFC(4oCg)
  pSubnetmask : [out]Tulbg}XN(4oCg)

  ݂̃lbg[Nݒ擾܂BKv̖NULLɂł܂B
*****************************************************************************/

/*****************************************************************************
  [LANp]
  SRV_STATUS SRV_SetDnsServer(BYTE *pIP)

  pIP : [in]DNST[o[IPAhX(4oCg)

  DNST[o[̃AhXݒ肵܂B
*****************************************************************************/

/*****************************************************************************
  [LANp]
  SRV_STATUS SRV_GetDnsServer(BYTE *pIP)

  pIP : [out]DNST[o[IPAhX(4oCg)

  ݂DNST[o[̃AhX擾܂B
*****************************************************************************/



