/*****************************************************************************
  M3069Lcd.h

  M3069Serial.dllp̃wb_[t@CBM3069}CR{[hŃLN^^Cv
  LCD𐧌䂷邽߂̃CuB

  쐬 : 2007/12/13
  XV : 

  Ver.1.0.0.1

  Copyright (C) eNmEF[u 2007
*****************************************************************************/
#ifndef __M3069LCD_H__
#define __M3069LCD_H__

//LCDɑ΂CXgNV
//ATF_LCDWriteReg()ňȉ̒lނƂLCD𐧌ł܂
#define ATF_LCD_CLEAR        0x01  //ʂNAăJ[\z[ɖ߂
#define ATF_LCD_HOME         0x02  //J[\z[ɖ߂

//ȉ3̃R}hORŌēɐݒ\ł
#define ATF_LCD_ENABLE       0x0c  //\
#define ATF_LCD_CRSR_ENABLE  0x0a  //J[\\
#define ATF_LCD_CRSR_BLINK   0x09  //J[\ʒu̕uN

#define ATF_LCD_DISABLE      0x08  //\It
#define ATF_LCD_CRSR_LEFT    0x10  //J[\Ɉړ
#define ATF_LCD_CRSR_RIGHT   0x14  //J[\EɈړ
#define ATF_LCD_SCRL_LEFT    0x18  //ʂɃXN[
#define ATF_LCD_SCRL_RIGHT   0x1c  //ʂEɃXN[
#define ATF_LCD_SET_DDRAM    0x80  //DDRAMAhXZbg
#define ATF_LCD_SET_CGRAM    0x40  //CGRAMAhXZbg


#ifdef __cplusplus
extern "C" {
#endif
TW_STATUS _stdcall ATF_LCDAttach(TW_HANDLE hDev);
TW_STATUS _stdcall ATF_LCDDetach(TW_HANDLE hDev);
TW_STATUS _stdcall ATF_LCDSetPort(TW_HANDLE hDev, DWORD Port);
TW_STATUS _stdcall ATF_LCDReadReg(TW_HANDLE hDev, BYTE *pReg);
TW_STATUS _stdcall ATF_LCDReadData(TW_HANDLE hDev, BYTE *pData);
TW_STATUS _stdcall ATF_LCDWriteReg(TW_HANDLE hDev, BYTE Reg);
TW_STATUS _stdcall ATF_LCDWriteData(TW_HANDLE hDev, BYTE Data);
TW_STATUS _stdcall ATF_LCDInit(TW_HANDLE hDev);
TW_STATUS _stdcall ATF_LCDPuts(TW_HANDLE hDev, LPCTSTR szData);
#ifdef __cplusplus
}
#endif


//****** ȉ̍s VisualStudio  IntelliSense ̂߂ɒǉĂ܂ *****
//****** ۂ̃\[XvOƂ͖֌Wł̂ŁAӂ         *****
//****** KvȂꍇɂ̓RgAEgĂ                     *****
#ifdef __USBM_INTELLISENSE__
/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDAttach(TW_HANDLE hDev)

  hDev : foCX̃nh

  LN^LCDp̃A^b`gt@[(M3069Lcd.atf)foCXɃ_E
  [h܂B̃Cu֐̎gpɐ旧ĕKĂяoKv܂B
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDAttach(TW_HANDLE hDev){ return 0 };

/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDDetach(TW_HANDLE hDev)

  hDev : foCX̃nh

  LN^LCDp̃A^b`gt@[̎gpI܂B
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDDetach(TW_HANDLE hDev){ return 0 };

/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDSetPort(TW_HANDLE hDev, DWORD Port)

  hDev : foCX̃nh
  Port : LCDƐڑ|[gw肵܂
         USBM_P4 : P40-P47gp܂
         USBM_PA : PA0-PA7gp܂

  LCDɎgp|[gw肵܂BftHgłP40-P47gp܂B
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDSetPort(TW_HANDLE hDev, DWORD Port){ return 0 };

/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDReadReg(TW_HANDLE hDev, BYTE *pReg)

  hDev : foCX̃nh
  pReg : [out]ǂݏoWX^̒l
         rbg0-6 : AhXJE^̒l
         rbg7   : rW[tO

  LCD̐䃌WX^(CXgNVEWX^)ǂݏos܂B
  ʏrbg0-rbg6Ɍ݂̃AhXJE^̒lArbg7ɃrW[tOi[
  ܂BڂLCD̃f[^V[gQƂĂB
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDReadReg(TW_HANDLE hDev, BYTE *pReg){ return 0 };

/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDReadData(TW_HANDLE hDev, BYTE *pData)

  hDev  : foCX̃nh
  pData : [out]ǂݏol
 
  \̈ƑΉDDRAMALN^`pCGRAMǂݏos܂B
  ATF_LCDWriteReg()DDRAMAhXZbg̃ANZXDDRAMACGRAMAh
  Xw肵̃ANZXCGRAMΏۂɍs܂B
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDReadData(TW_HANDLE hDev, BYTE *pData){ return 0 };

/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDWriteReg(TW_HANDLE hDev, BYTE Reg)

  hDev : foCX̃nh
  Reg  : ޒl
         ATF_LCD_CLEAR(0x01)       : ʂNAăJ[\z[ɖ߂
         ATF_LCD_HOME(0x02)        : J[\z[ɖ߂
         ATF_LCD_ENABLE(0x0c)      : \
         ATF_LCD_CRSR_ENABLE(0x0a) : J[\\
         ATF_LCD_CRSR_BLINK(0x09)  : J[\ʒu̕uN
         ATF_LCD_DISABLE(0x08)     : \It
         ATF_LCD_CRSR_LEFT(0x10)   : J[\Ɉړ
         ATF_LCD_CRSR_RIGHT(0x14)  : J[\EɈړ
         ATF_LCD_SCRL_LEFT(0x18)   : ʂɃXN[
         ATF_LCD_SCRL_RIGHT(0x1c)  : ʂEɃXN[
         ATF_LCD_SET_DDRAM(0x80)   : DDRAMAhXZbg
         ATF_LCD_SET_CGRAM(0x40)   : CGRAMAhXZbg

  LCD̐䃌WX^(CXgNVEWX^)ɏ݂s܂B
  ATF_LCD_ENABLEAATF_LCD_CRSR_ENABLEAATF_LCD_CRSR_BLINK ORŌď
  ނƂł܂B
  ATF_LCDWriteData()ȂǂŃANZXRAMAhXw肷ꍇ́A
  ATF_LCD_SET_DDRAMAATF_LCD_SET_CGRAMRAMAhXORŌď݂s
  ܂B
  CXgNVɊւڍׂLCD̃f[^V[gQƂĂB
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDWriteReg(TW_HANDLE hDev, BYTE Reg){ return 0 };

/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDWriteData(TW_HANDLE hDev, BYTE Data)

  hDev : foCX̃nh
  Data : ޒl

  \̈ƑΉDDRAMALN^`pCGRAMɏ݂s܂B
  ATF_LCDWriteReg()DDRAMAhXZbg̃ANZXDDRAMACGRAMAh
  Xw肵̃ANZXCGRAMΏۂɍs܂B
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDWriteData(TW_HANDLE hDev, BYTE Data){ return 0 };

/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDInit(TW_HANDLE hDev)

  hDev : foCX̃nh

  LCD܂BLCD̓dɕKs܂B
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDInit(TW_HANDLE hDev){ return 0 };

/*****************************************************************************
  TW_STATUS _stdcall ATF_LCDPuts(TW_HANDLE hDev, LPCTSTR szData)

  hDev   : foCX̃nh
  szData : \镶

  LCDɕ\܂B
*****************************************************************************/
TW_STATUS _stdcall ATF_LCDPuts(TW_HANDLE hDev, LPCTSTR szData){ return 0 };


#endif

#endif /*__M3069LCD_H__*/