'**********************************************************************************
'   M3069}CR{[hDLL(USBM3069.DLL)p`t@C VB.NETΉ
'
'   2005/11/11 Ver.2.1.0.1 : 2.0t@[EFAΉ
'   2006/8/21  Ver.2.2.0.1 : DLL2.2Ή萔ǉUSBM_GetFTHandle()ǉ
'   2007/1/15  Ver.2.2.0.2 : USBM_TCPYSetPatternCtrl()̈Xg̃oOC
'   2007/2/14  Ver.3.1.0.1 : LANM3069ɑΉ
'   2007/5/18  Ver.3.1.1.1 : Windows CE (4.2-5.0)ɑΉ
'   2007/10/18 Ver.3.3.0.1 : [U[t@[ɑΉ
'   2007/11/7  Ver.3.3.0.2 : ꕔ̒萔̌^w
'**********************************************************************************

Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices

Module USBM3069
    '------------------------------------------------------------------------------
    '   FTD2XX.h Ή
    '------------------------------------------------------------------------------

    'Device status
    Public Enum USBM_FTD2XX_STATUS
        FT_OK
        FT_INVALID_HANDLE
        FT_DEVICE_NOT_FOUND
        FT_DEVICE_NOT_OPENED
        FT_IO_ERROR
        FT_INSUFFICIENT_RESOURCES
        FT_INVALID_PARAMETER
        FT_INVALID_BAUD_RATE
        FT_DEVICE_NOT_OPENED_FOR_ERASE
        FT_DEVICE_NOT_OPENED_FOR_WRITE
        FT_FAILED_TO_WRITE_DEVICE
        FT_EEPROM_READ_FAILED
        FT_EEPROM_WRITE_FAILED
        FT_EEPROM_ERASE_FAILED
        FT_EEPROM_NOT_PRESENT
        FT_EEPROM_NOT_PROGRAMMED
        FT_INVALID_ARGS
        FT_NOT_SUPPORTED
        FT_OTHER_ERROR
    End Enum

    'Device status
    Public Enum M3069_STATUS
        TW_OK
        TW_INVALID_HANDLE
        TW_DEVICE_NOT_FOUND
        TW_DEVICE_NOT_OPENED
        TW_IO_ERROR
        TW_INSUFFICIENT_RESOURCES
        TW_INVALID_PARAMETER
        TW_INVALID_BAUD_RATE
        TW_DEVICE_NOT_OPENED_FOR_ERASE
        TW_DEVICE_NOT_OPENED_FOR_WRITE
        TW_FAILED_TO_WRITE_DEVICE
        TW_EEPROM_READ_FAILED
        TW_EEPROM_WRITE_FAILED
        TW_EEPROM_ERASE_FAILED
        TW_EEPROM_NOT_PRESENT
        TW_EEPROM_NOT_PROGRAMMED
        TW_INVALID_ARGS
        TW_NOT_SUPPORTED
        TW_OTHER_ERROR
        '>Ver.3.1.0.x
        TW_TIMEOUT = &HFFFF0001 'M܂͎M^CAEg
        TW_FILE_ERROR           't@CɊւG[
        TW_MEMORY_ERROR         '̊mۃG[
        TW_DATA_NOT_FOUND       'Lȃf[^
        TW_SOCKET_ERROR         'Socket API ̃G[
        TW_ACCESS_DENIED        'F؃G[
        '<Ver.3.1.0.x
    End Enum

    '>Ver.3.1.0.x
    'ii[p\
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure UUID
        Public Data1 As Integer
        Public Data2 As Short
        Public Data3 As Short
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=8)> _
        Public Data4() As Byte
    End Structure

    'Windows CE p錾
    'oDescriptionManufacture̓oCgzƂĐ錾܂B
    'ANSI񂪊i[܂̂ŕƂĈ߂ɂUNICODE
    'ϊKv܂B
#If PocketPC = True Then
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure USBM_PRODUCT_INFO
        Public Empty As Short
        Public wRsv As Short
        Public ID As UUID
        Public Number As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
        Public Description() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
        Public Manufacture() As Byte
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=40)> _
        Public Reserve() As Byte
    End Structure
#Else
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi, Pack:=4)> _
    Public Structure USBM_PRODUCT_INFO
        Public Empty As Short
        Public wRsv As Short
        Public ID As UUID
        Public Number As Integer
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public Description As String
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public Manufacture As String
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=40)> _
        Public Reserve() As Byte
    End Structure
#End If

    '<Ver.3.1.0.x

    '>Ver.3.3.0.1
    'Windows CE p錾
    'oDescriptionManufacture̓oCgzƂĐ錾܂B
    'ANSI񂪊i[܂̂ŕƂĈ߂ɂUNICODE
    'ϊKv܂B
#If PocketPC = True Then
    <StructLayout(LayoutKind.Sequential)> _
    Public Structure USBM_ATF_INFO
        Public FormatVer As Integer
        Public FirmwareVer As Integer
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
        Public Description() As Byte 
        <MarshalAs(UnmanagedType.ByValArray, SizeConst:=32)> _
        Public Manufacture() As Byte
        Public ProgramVer As Integer
        Public AddressTop As Integer
        Public AddressBottom As Integer
        Public CommandAddress As Integer
        Public EncryptMode As Short
        Public wRsv As Short
        Public MainAddress As Integer
    End Structure
#Else
    <StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Ansi, Pack:=4)> _
    Public Structure USBM_ATF_INFO
        Public FormatVer As Integer      't@CtH[}bg̃o[W
        Public FirmwareVer As Integer    'Kvȃt@[EFÃo[W
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public Description As String     'ATF̖́AȂ
        <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=32)> _
        Public Manufacture As String     '
        Public ProgramVer As Integer     '[߂ĂvÕo[W
        Public AddressTop As Integer     'gpRAM̈̐擪AhX
        Public AddressBottom As Integer  'gpRAM̈̍ŏIAhX+1
        Public CommandAddress As Integer 'R}hnh̃AhX
        Public EncryptMode As Short      'Í(0:ȂA1:\A2:[U[pX[hɂÍ)
        Public wRsv As Short
        Public MainAddress As Integer    'C֐̃AhX
    End Structure
#End If
    '<Ver.3.3.0.1

    '------------------------------------------------------------------------------
    '   USBM3069.h ΉF萔`
    '------------------------------------------------------------------------------
    '>Ver.3.1.0.x
    Public Const USBM_IF_USB As Integer = &H80000000 'USBC^tF[X
    Public Const USBM_IF_LAN As Integer = &H40000000 'LANC^tF[X
    Public Const USBM_IF_ANY As Integer = &HFF000000 'SẴC^tF[Xƃ}b`

    Public Const USBM_LIST_UPDATE As Integer = &H1   'LANfoCX̓e[uXV邩̃tO
    '<Ver.3.1.0.x

    '>Ver.3.3.0.1
    Public Const TW_ATF_STATUS As Integer = &HFFFFFE00  'ATFŋʂɎgpXe[^X̐擪ԍ
    Public Const TW_USER_STATUS As Integer = &HFFFFFF00 '[U[`̃Xe[^X̐擪ԍ
    '<Ver.3.3.0.1

    'Xe[^X
    Public Const USBM_STS_TIMEOUT As Short = &H1S
    Public Const USBM_STS_ILLEGAL_ACCESS As Short = &H2S

    '|[gAhX
    Public Const USBM_POUT As Integer = &HFFFFFFFF 'POUT(o͐p)ʂ̃AhX
    Public Const USBM_P1 As Integer = &HFFFFD0 'P1(͐p)
    Public Const USBM_P2 As Integer = &HFFFFD1 'P2(͐p)
    Public Const USBM_P4 As Integer = &HFFFFD3 'P4(o)
    Public Const USBM_P5 As Integer = &HFFFFD4 'P5(͐p)
    Public Const USBM_PA As Integer = &HFFFFD9 'PA(o)

    'DARo[^̃AhX
    Public Const USBM_DA0 As Integer = &HFFFF9C
    Public Const USBM_DA1 As Integer = &HFFFF9D

    'OoX̃AhX
    Public Const USBM_AREA0_TOP As Integer = &H100000
    Public Const USBM_AREA2_TOP As Integer = &H400000
    Public Const USBM_AREA3_TOP As Integer = &H600000
    Public Const USBM_AREA5_TOP As Integer = &HA00000
    Public Const USBM_USER_AREA As Integer = &HFFBF20

    'PCs(IRQ)ǂނ߂IO|[gAhX
    Public Const USBM_PC0_ADDR As Integer = &HFFFFD8
    Public Const USBM_PC1_ADDR As Integer = &HFFFFD8
    Public Const USBM_PC2_ADDR As Integer = &HFFFFD7
    Public Const USBM_PC3_ADDR As Integer = &HFFFFD7

    'PCs(IRQ)ǂނ߂̃rbg}XN
    Public Const USBM_PC0_BIT As Short = &H10S
    Public Const USBM_PC1_BIT As Short = &H20S
    Public Const USBM_PC2_BIT As Short = &H2S
    Public Const USBM_PC3_BIT As Short = &H4S

    '16rbg^C}NbN
    Public Const USBM_TCLK25000 As Short = &H0S '25MHz
    Public Const USBM_TCLK12500 As Short = &H1S '12.5MHz
    Public Const USBM_TCLK6250 As Short = &H2S '625kHz
    Public Const USBM_TCLK3125 As Short = &H3S '3125kHz
    Public Const USBM_TCLKA As Short = &H4S 'TCLKA
    Public Const USBM_TCLKB As Short = &H5S 'TCLKB

    'TCPY(8rbg^C})p
    Public Const USBM_TCLK390 As Short = &H6S '390.625kHz
    Public Const USBM_TCLK3 As Short = &H7S '3052Hz
    Public Const USBM_TCLKUP As Short = &H8S 'ONbNオ
    Public Const USBM_TCLKDOWN As Short = &H9S 'ONbN
    Public Const USBM_TCLKBOTH As Short = &HAS 'ONbNGbW

    Public Const USBM_SCI_DATA8 As Short = &H0S '8rbgf[^
    Public Const USBM_SCI_DATA7 As Short = &H40S '7rbgf[^
    Public Const USBM_SCI_NOPARITY As Short = &H0S 'peBȂ
    Public Const USBM_SCI_EVEN As Short = &H20S 'peB
    Public Const USBM_SCI_ODD As Short = &H30S 'peB
    Public Const USBM_SCI_STOP1 As Short = &H0S '1Xgbvrbg
    Public Const USBM_SCI_STOP2 As Short = &H8S '2Xgbvrbg
    Public Const USBM_SCI_BAUD300 As Short = &H2A2S '9rbg=CKS1,8rbg=CKS0,7-0rbg=BRR,
    Public Const USBM_SCI_BAUD600 As Short = &H250S
    Public Const USBM_SCI_BAUD1200 As Short = &H1A2S
    Public Const USBM_SCI_BAUD2400 As Short = &H150S
    Public Const USBM_SCI_BAUD4800 As Short = &HA2S
    Public Const USBM_SCI_BAUD9600 As Short = &H50S
    Public Const USBM_SCI_BAUD14400 As Short = &H35S
    Public Const USBM_SCI_BAUD19200 As Short = &H28S
    Public Const USBM_SCI_BAUD38400 As Short = &H13S

    'GA\萔
    Public Const USBM_AREA0 As Short = &H1S
    Public Const USBM_AREA2 As Short = &H4S
    Public Const USBM_AREA3 As Short = &H8S
    Public Const USBM_AREA5 As Short = &H10S

    'pXJE^\萔
    Public Const USBM_PC0 As Short = &H10S
    Public Const USBM_PC1 As Short = &H20S
    Public Const USBM_PC2 As Short = &H2S
    Public Const USBM_PC3 As Short = &H4S
    Public Const USBM_PC_ALL As Short = -1

    ' Purge rx and tx buffers
    Public Const FT_PURGE_RX As Short = 1
    Public Const FT_PURGE_TX As Short = 2
    Public Const USBM_PURGE_RX As Short = 1
    Public Const USBM_PURGE_TX As Short = 2

    '16rbg^C}CvbgLv`pGbWݒ
    Public Const USBM_CAPT_RISE As Short = &H4S
    Public Const USBM_CAPT_FALL As Short = &H5S
    Public Const USBM_CAPT_BOTH As Short = &H7S

    '------------------------------------------------------------------------------
    '   USBM3069.h ΉF֐`
    '------------------------------------------------------------------------------

    Public Declare Function USBM_ListDevicesX Lib "USBM3069.dll" Alias "USBM_ListDevices" (ByVal pSerial As String, ByVal nSerial As Integer) As Integer
    Public Declare Function USBM_ListDevicesByIDX Lib "USBM3069.dll" Alias "USBM_ListDevicesByID" (ByVal VID As Short, ByVal PID As Short, ByVal pSerial As String, ByVal nSerial As Integer) As Integer
    Public Declare Function USBM_OpenByUA Lib "USBM3069.dll" (ByVal pUA As String, ByVal nUA As Integer) As Integer
    Public Declare Function USBM_Open Lib "USBM3069.dll" (Optional ByVal pSerial As String = vbNullString) As Integer
    Public Declare Function USBM_OpenByID Lib "USBM3069.dll" (ByVal VID As Short, ByVal PID As Short, Optional ByVal pSerial As String = vbNullString) As Integer
    Public Declare Function USBM_Close Lib "USBM3069.dll" (ByVal hDev As Integer) As Integer

    Public Declare Function USBM_Initialize Lib "USBM3069.dll" (ByVal hDev As Integer) As Integer
    Public Declare Function USBM_AddressEnable Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal nBits As Integer) As Integer
    Public Declare Function USBM_CSEnable Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Area As Integer) As Integer
    Public Declare Function USBM_BusSetWait Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Area As Integer, ByVal Wait As Byte) As Integer

    Public Declare Function USBM_PortRead8 Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByRef pData As Byte) As Integer
    Public Declare Function USBM_PortWrite8 Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal Data As Byte) As Integer
    Public Declare Function USBM_PortRead16 Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByRef pData As Short) As Integer
    Public Declare Function USBM_PortWrite16 Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal Data As Short) As Integer
    Public Declare Function USBM_PortBWrite Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal pData() As Byte, ByVal nData As Integer, Optional ByVal Inc As Integer = 1, Optional ByVal Dma As Byte = 1) As Integer
    Public Declare Function USBM_PortBWrite Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal pData() As Short, ByVal nData As Integer, Optional ByVal Inc As Integer = 1, Optional ByVal Dma As Byte = 1) As Integer
    Public Declare Function USBM_PortBWrite Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal pData() As Integer, ByVal nData As Integer, Optional ByVal Inc As Integer = 1, Optional ByVal Dma As Byte = 1) As Integer
    Public Declare Function USBM_PortBRead Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal pData() As Byte, ByVal nData As Integer, Optional ByVal Inc As Integer = 1, Optional ByVal Dma As Byte = 1) As Integer
    Public Declare Function USBM_PortBRead Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal pData() As Short, ByVal nData As Integer, Optional ByVal Inc As Integer = 1, Optional ByVal Dma As Byte = 1) As Integer
    Public Declare Function USBM_PortBRead Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal pData() As Integer, ByVal nData As Integer, Optional ByVal Inc As Integer = 1, Optional ByVal Dma As Byte = 1) As Integer
    Public Declare Function USBM_PortSetDir Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_PortBCopy Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal SrcPort As Integer, ByVal DstPort As Integer, ByVal nData As Integer, ByVal SrcInc As Integer, ByVal DstInc As Integer) As Integer
    Public Declare Function USBM_PortCopy8 Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal SrcPort As Integer, ByVal DstPort As Integer) As Integer
    Public Declare Function USBM_PortCopy16 Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal SrcPort As Integer, ByVal DstPort As Integer) As Integer

    Public Declare Function USBM_TimerEnable Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte, ByVal MDF As Integer) As Integer
    Public Declare Function USBM_TimerSetLevel Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_TimerSetPulse Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal High As Short, ByVal Low As Short) As Integer
    Public Declare Function USBM_TimerSetClk Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_TimerSetCnt Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Cnt As Short) As Integer
    Public Declare Function USBM_TimerStart Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_TimerReadCnt Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByRef pCnt As Short) As Integer
    Public Declare Function USBM_TimerSetCmp Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CmpA As Short, ByVal CmpB As Short) As Integer
    Public Declare Function USBM_TimerSetCmpOut Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CmpReg As Integer, ByVal Port As Integer, ByVal Data As Byte) As Integer
    Public Declare Function USBM_TimerSetCmpClr Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer

    Public Declare Function USBM_ADRead Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal pData() As Short, ByVal CH As Integer, Optional ByVal Scan As Integer = 0) As Integer
    Public Declare Function USBM_ADSetCycle Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Cmp As Byte, Optional ByVal CLK As Integer = USBM_TCLK3125) As Integer
    Public Declare Function USBM_ADBRead Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal pData() As Short, ByVal nData As Integer, ByVal CH As Integer, ByRef pnRead As Integer) As Integer

    Public Declare Function USBM_SCISetMode Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, Optional ByVal Mode As Integer = &H0I, Optional ByVal Baud As Integer = &H50I) As Integer
    Public Declare Function USBM_SCIReadStatus Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByRef pStatus As Byte, ByRef pnReceive As Integer) As Integer
    Public Declare Function USBM_SCIRead Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal pData() As Byte, ByVal nData As Integer, ByRef pnRead As Integer) As Integer
    Public Declare Function USBM_SCIWrite Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal pData() As Byte, ByVal nData As Integer) As Integer
    Public Declare Function USBM_SCISetTimeout Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Millisec As Integer) As Integer

    Public Declare Function USBM_PCSetCmp Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Cmp As Integer) As Integer
    Public Declare Function USBM_PCSetCnt Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Cnt As Integer) As Integer
    Public Declare Function USBM_PCReadCnt Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal pCnt() As Integer) As Integer
    Public Declare Function USBM_PCSetControl Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_PCSetCondBit Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Port As Integer, ByVal Mask As Byte) As Integer
    Public Declare Function USBM_PCSetCmpOut Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Port As Integer, ByVal Data As Byte) As Integer
    Public Declare Function USBM_PCStart Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer

    Public Declare Function USBM_TCPYStart Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_TCPYSetParm Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal SrcPort As Integer, ByVal DstPort As Integer, ByVal nCopy As Integer, ByVal SrcInc As Integer, ByVal DstInc As Integer, ByVal lLoop As Integer) As Integer
    Public Declare Function USBM_TCPYSetCmp Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Cmp As Byte) As Integer
    Public Declare Function USBM_TCPYSetClk Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal CLK As Integer) As Integer
    Public Declare Function USBM_TCPYSetCycle Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Cmp As Byte, Optional ByVal CLK As Integer = USBM_TCLK3125) As Integer

    Public Declare Function USBM_Write Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Data() As Byte, ByVal nData As Integer, ByRef pWritten As Integer) As Integer
    Public Declare Function USBM_Write Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Data() As Short, ByVal nData As Integer, ByRef pWritten As Integer) As Integer
    Public Declare Function USBM_Write Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Data() As Integer, ByVal nData As Integer, ByRef pWritten As Integer) As Integer
    Public Declare Function USBM_Read Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Data() As Byte, ByVal nData As Integer, ByRef pRead As Integer) As Integer
    Public Declare Function USBM_Read Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Data() As Short, ByVal nData As Integer, ByRef pRead As Integer) As Integer
    Public Declare Function USBM_Read Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Data() As Integer, ByVal nData As Integer, ByRef pRead As Integer) As Integer
    Public Declare Function USBM_ReadStatus Lib "USBM3069.dll" (ByVal hDev As Integer, ByRef pStat As Integer) As Integer
    Public Declare Function USBM_ReadVersion Lib "USBM3069.dll" (ByVal hDev As Integer, ByRef pVer As Integer) As Integer

    Public Declare Function USBM_Abort Lib "USBM3069.dll" (ByVal hDev As Integer) As Integer

    Public Declare Function USBM_TimerStartA Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte, Optional ByVal TrigPC As Integer = -1, Optional ByVal Repeat As Integer = False, Optional ByVal Cmp As Integer = 1) As Integer
    Public Declare Function USBM_TimerStop Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte, Optional ByVal TrigPC As Integer = -1, Optional ByVal Repeat As Integer = False, Optional ByVal Cmp As Integer = 1) As Integer
    Public Declare Function USBM_DASetCycle Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Cmp As Integer, ByVal CLK As Integer) As Integer
    Public Declare Function USBM_DASetParm Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal SrcPort As Integer, ByVal nData As Integer, ByVal lLoop As Integer) As Integer
    Public Declare Function USBM_DAReadStatus Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByRef pnData As Integer) As Integer
    Public Declare Function USBM_DAStart Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_DAStop Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_TCPYSetPatternCtrl Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal SrcPort As Integer, ByVal DstPort As Integer, ByVal nCopy As Integer, ByVal nSrc As Integer, ByVal SrcInc As Integer, Optional ByVal Start As Integer = 0, Optional ByVal Msak As Byte = &HFF) As Integer
    Public Declare Function USBM_TCPYSetTrig Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal StartPC As Integer, ByVal StopPC As Integer, ByVal flgRepeat As Integer) As Integer
    Public Declare Function USBM_TCPYReadStatus Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByRef pnCopy As Integer, ByRef pSrcPos As Integer) As Integer
    Public Declare Function USBM_TimerSetCapture Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, Optional ByVal EdgeA As Byte = USBM_CAPT_RISE, Optional ByVal EdgeB As Byte = USBM_CAPT_RISE) As Integer
    Public Declare Function USBM_TimerReadCaptureCnt Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByRef pCntA As Integer, ByRef pCntB As Integer) As Integer
    Public Declare Function USBM_TimerSetCaptureCnt Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, Optional ByVal CntA As Integer = 0, Optional ByVal CntB As Integer = 0) As Integer

    Public Declare Function USBM_ADStart Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal nCnv As Integer, ByVal CH As Integer, ByVal Scan As Integer, Optional ByVal lByte As Integer = False, Optional ByVal Trig As Integer = False) As Integer
    Public Declare Function USBM_ADCopy Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal DstPort As Integer, ByVal nCnv As Integer, ByVal CH As Integer, ByVal CKS As Integer, ByVal DMA_CH As Integer, Optional ByVal DstInc As Integer = True) As Integer
    Public Declare Function USBM_ADReadCopyStatus Lib "USBM3069.dll" (ByVal hDev As Integer, ByRef pnCnv As Integer, ByVal DMA_CH As Integer) As Integer
    Public Declare Function USBM_ADReadCopyBuffer Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal pData() As Short, ByVal nData As Integer, ByVal Inc As Integer, ByVal Dma As Byte) As Integer
    Public Declare Function USBM_ADStopCopy Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal DMA_CH As Integer) As Integer
    Public Declare Function USBM_SCISetDelimiter Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal pData() As Byte, ByVal nDelimiter As Integer) As Integer
    Public Declare Function USBM_GetQueueStatus Lib "USBM3069.dll" (ByVal hDev As Integer, ByRef pnQueue As Integer) As Integer
    Public Declare Function USBM_Purge Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal dwMask As Integer) As Integer
    Public Declare Function USBM_SetTimeouts Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal dwReadTimeout As Integer, ByVal dwWriteTimeout As Integer) As Integer
    Public Declare Function USBM_PCStartA Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_PCStop Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Bits As Byte) As Integer
    Public Declare Function USBM_TimerSetSinglePulse Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal CH As Integer, ByVal Setup As Integer, ByVal Width As Integer, Optional ByVal Pos As Integer = False) As Integer

    Public Declare Function USBM_GetFTHandle Lib "USBM3069.dll" (ByVal hDev As Integer) As Integer

    Public Declare Function FT_Purge Lib "FTD2XX.dll" (ByVal hDev As Integer, ByRef dwMask As Integer) As Integer
    Public Declare Function FT_SetTimeouts Lib "FTD2XX.dll" (ByVal hDev As Integer, ByVal dwReadTimeout As Integer, ByVal dwWriteTimeout As Integer) As Integer

    '>Ver.3.1.0.x
    Public Declare Function USBM_ReadPI Lib "USBM3069.dll" (ByVal hDev As Integer, ByRef pInfo As USBM_PRODUCT_INFO) As Integer
    Public Declare Function USBM_OpenByPI Lib "USBM3069.dll" (ByRef phDev As Integer, ByVal pUuid As String, ByVal Number As Integer, ByVal Opt As Integer) As Integer
    Public Declare Function USBM_PortWrite8A Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Port As Integer, ByVal Data As Byte, Optional ByVal Mask As Byte = &HFF) As Integer

    Public Declare Function USBM_SetPassword Lib "USBM3069.dll" (Optional ByVal pPass As String = vbNullString) As Integer
    Public Declare Function USBM_SetNetworkPort Lib "USBM3069.dll" (Optional ByVal PortNumber As Integer = 0) As Integer
    Public Declare Function USBM_GetIFType Lib "USBM3069.dll" (ByVal hDev As Integer) As Integer
    Public Declare Function USBM_OpenA Lib "USBM3069.dll" (ByRef phDev As Integer, Optional ByVal pID As String = vbNullString, Optional ByVal Opt As Integer = USBM_IF_ANY Or USBM_LIST_UPDATE) As Integer
    Public Declare Function USBM_ListDevicesA Lib "USBM3069.dll" (ByRef pnDev As Integer, ByVal pID As System.Text.StringBuilder, ByRef pnID As Integer, ByVal Opt As Integer) As Integer
    '<Ver.3.1.0.x

    '>Ver.3.3.0.1
    Public Declare Function USBM_ReadVersionA Lib "USBM3069.dll" (ByVal hDev As Integer, ByRef pVersion As Integer) As Integer
    Public Declare Function USBM_ATFSetCommand Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Address As Integer) As Integer
    Public Declare Function USBM_ATFSetMain Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Address As Integer) As Integer
    Public Declare Function USBM_ATFUserCommand Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Command As Short, ByVal Param1 As Integer, ByVal Param2 As Integer, <MarshalAs(UnmanagedType.AsAny)> Optional ByVal pData As Object = Nothing, Optional ByVal nData As Integer = 0) As Integer
    'Public Declare Function USBM_ATFUserCommand Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal Command As Short, ByVal Param1 As Integer, ByVal Param2 As Integer, <MarshalAs(UnmanagedType.LPWStr)> ByVal pData As String, Optional ByVal nData As Integer = 0) As Integer 'pDataUNICODEn߂̃I[o[[h
    Public Declare Function USBM_ATFDownload Lib "USBM3069.dll" (ByVal hDev As Integer, ByVal FileName As String, Optional ByVal Reserve As String = vbNullString) As Integer
    Public Declare Function USBM_ATFGetInfo Lib "USBM3069.dll" (ByVal FileName As String, ByRef pInfo As USBM_ATF_INFO) As Integer
    '<Ver.3.3.0.1

    '------------------------------------------------------------------------------
    '   l^ϊp֐
    '------------------------------------------------------------------------------
    Public Function USBM_ToUINT16(ByVal data As Integer) As Short

        If data < 0 Then
            USBM_ToUINT16 = 0
        ElseIf data <= &H7FFFI Then
            USBM_ToUINT16 = data
        ElseIf data <= &HFFFFI Then
            USBM_ToUINT16 = (data - &H10000I)
        Else
            USBM_ToUINT16 = &HFFFFS
        End If

    End Function

    Public Function USBM_ToINT32(ByVal data As Short) As Integer

        USBM_ToINT32 = data
        USBM_ToINT32 = USBM_ToINT32 And &HFFFFI

    End Function

    '------------------------------------------------------------------------------
    '   bp[֐
    '------------------------------------------------------------------------------
    Public Function USBM_ListDevices(ByRef pSerial() As String) As Integer
        Dim nSerial As Integer = UBound(pSerial) + 1
        Dim buf As String = New String(Chr(0), 9 * nSerial)
        Dim n As Integer
        Dim i As Integer
        n = USBM_ListDevicesX(buf, nSerial)
        For i = 0 To (n - 1)
            pSerial(i) = buf.Substring(i * 9)
        Next
        USBM_ListDevices = n
    End Function

    Public Function USBM_ListDevicesByID(ByVal VID As Short, ByVal PID As Short, ByRef pSerial() As String) As Integer
        Dim nSerial As Integer = UBound(pSerial) + 1
        Dim buf As String = New String(Chr(0), 9 * nSerial)
        Dim n As Integer
        Dim i As Integer
        n = USBM_ListDevicesByIDX(VID, PID, buf, nSerial)
        For i = 0 To (n - 1)
            pSerial(i) = buf.Substring(i * 9)
        Next
        USBM_ListDevicesByID = n
    End Function

End Module